import React from "react";
import { DescriptiveReference } from "../../../common/graph/node";

interface ReferencesProps {
    references: DescriptiveReference[];
}

/**
 * Displays a list of links.
 * @param references List of links.
 * @constructor
 */
function References({ references }: ReferencesProps) {
    return (
        <ul>
            {references.map((ref) => (
                <li key={ref.url}>
                    <a
                        href={ref.url}
                        rel={"noopener noreferrer"}
                        target={"_blank"}
                    >
                        {ref.description}
                    </a>
                </li>
            ))}
        </ul>
    );
}

export default References;
